SystemOrganization addCategory: #'GT-InspectorExtensions-Core'!

!MetacelloProject methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/14/2014 23:01'!
gtInspectorVersionsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Versions';
		display: #versions! !

!Pragma class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/4/2013 22:16'!
gtInspectorAnnotatedMethodsIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite table 
		title: 'All';
		showOnly: 50;
		withSmalltalkSearch;
		display: [:anObject | 
			| pragmas |
			pragmas := OrderedCollection new.
			Object withAllSubclassesDo: [:each |
				Pragma withPragmasIn: each do: [:p |
					pragmas add: p]].
			(pragmas groupedBy: #keyword) associations sorted: [ :a :b | 
				a key < b key ]
		];
		column: 'Keyword' evaluated: [ :each | each key ];
		column: 'Instances' evaluated: [ :each | each value size asString ];
		send: #value! !

!Pragma methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/7/2014 16:14'!
gtDisplayOn: stream
	self method gtDisplayOn: stream.
	stream space.
	self printOn: stream! !

!Pragma methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/6/2013 22:09'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!String methodsFor: '*GT-InspectorExtensions-Core' stamp: 'JurajKubelka 3/28/2015 18:03'!
gtDisplayOn: aStream
	self printOn: aStream.! !

!String methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/23/2015 17:07'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: -10>
	composite text
		title: 'String';
		display: [ self truncateWithElipsisTo: 100000 ]! !

!BlockClosure methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/23/2014 15:32'!
gtInspectorSourceCodeIn: composite 
	<gtInspectorPresentationOrder: 40>
	self sourceNode gtInspectorSourceCodeIn: composite! !

!Collection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 12/1/2016 20:47'!
gtCollectionSizeThreshold
	"Return the maximum collection size that GT supports while showing all elements.
	When this threshold is reached, we no longer show certain views that would take too much resources."

	^ 16rFFFF "65535"! !

!Collection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 12/1/2016 20:47'!
gtDisplayOn: stream
	self printNameOn: stream.
	stream
		space;
		nextPut: $[;
		print: self size;
		nextPutAll: (' item' asPluralBasedOn: self size);
		nextPut: $];
		space.
	self size <= self gtCollectionSizeThreshold 
		ifTrue: [ self printElementsOn: stream ]! !

!Collection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:51'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 0>  
	^ (composite list)
		title: 'Items';
		display: [ :aCollection | self ];
		beMultiple;
		withSmalltalkSearch;		
		format: [ :each | GTObjectPrinter new asTruncatedTextFrom: each ];
		send: [ :result | result isNil 
			ifTrue:[nil]
			ifFalse:[ (result size = 1) 
				ifTrue: [result anyOne] 
				ifFalse: [self species withAll: result]]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/1/2014 23:50'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 4>
	composite list 
		title: 'Implementors';
		display: [ self compiledMethod implementors ]! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/1/2014 23:50'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 2>
	composite list 
		title: 'Senders';
		display: [ self compiledMethod senders ]! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/13/2015 21:42'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 00>
	^ composite pharoMethod 
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self sourceCode ];
		act: [ :text | self methodClass compile: text text notifying: nil ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s
			entitled: 'Accept';
		act: [ self browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			entitled: 'Browse'! !

!RPackage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/6/2014 14:21'!
gtInspectorDefinedClassesIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list
		title: 'Classes';
		display: #classes;
		format: #gtDisplayString;
		tags: [ :each | each category ]! !

!RPackage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/6/2014 14:21'!
gtInspectorTagsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Tags';
		display: #classTags;
		format: #gtDisplayString;
		when: [ self classTags notEmpty ]! !

!ReadStream methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 13:00'!
gtInspectorStreamStateIn: composite
	<gtInspectorPresentationOrder: 50>
	(composite wrapper with: [ :w | 
		w title: 'Contents'.
		w show: [ :a | 
			a text
				display: [ self contents ];
				initialize: [ :aPresentation | 
					aPresentation selectionInterval: (1 to: self position) ] ] ])
		startOn: self! !

!MethodModified methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 8/21/2014 19:43'!
gtMethodDiffIn: aComposite
	<gtInspectorPresentationOrder: 40>
	aComposite diff
		title: 'Diff';
		display: [ 
			Array 
				with: self newMethod sourceCode
				with: self oldMethod sourceCode ]
! !

!Integer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/3/2014 14:45'!
gtInspectorIntegerIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Integer';
		display: [ | associations |
			associations :=	{
					'decimal' -> self printString.
					'hex' -> self printStringHex.
					'octal' -> (self printStringBase: 8).
					'binary' -> (self printStringBase: 2)} asOrderedCollection.
			(self between: 0 and: 16r10FFFF)
				ifTrue: [ associations add: 'character' -> self asCharacter ].
			associations ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: [ :each | each value printString ];
		send: #value! !

!Character methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/3/2014 14:59'!
gtInspectorCharacterIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Character';
		display: [
			{'self' -> self.
			'codepoint' -> self codePoint.
			'unicode' -> (String streamContents: [ :stream | 
				stream << 'U+'.
				self codePoint printOn: stream base: 16 nDigits: 4 ])} ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: [ :each | each value printString ];
		send: #value! !

!RBRefactoryChange methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/8/2016 11:58'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 0>
	composite diff
		title: 'Changes';
		display: [ { self oldVersionTextToDisplay . self textToDisplay } ]! !

!KMDispatcher methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 12/1/2015 16:24'!
gtAllKeyCategoryPairs

	^ ((self targets collect: #category)
			add: self directKeymaps;
			yourself)
			flatCollect: [ :category | 
				category allEntries keymaps collect: [ :key | key -> category ] ]! !

!KMDispatcher methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 12/1/2015 16:25'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Keys';
		display: [ 
			self gtAllKeyCategoryPairs ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!AbstractMorphicAdapter methodsFor: '*GT-InspectorExtensions-Core' stamp: 'PeterUhnak 9/3/2015 17:40'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 30>
	
	self widgetDo: [ :w | w gtInspectorMorphIn: composite ]! !

!ByteArray methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/22/2016 00:27'!
gtInspectorBytesIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Bytes';
		display: [ 
			(self size < 2048 or: [ self confirm: 'Looking at more than 2048 bytes might be slow. Continue ?' ])
				ifTrue: [ {
					'hex string' -> (String streamContents: [ :out | 
						self do: [ :each | 
							each printOn: out base: 16 nDigits: 2 ] ]).
					'hex lines' -> (String streamContents: [ :out |
						self withIndexDo: [ :each :index |
							index = 1 ifFalse: [ 
								index - 1 \\ 8 = 0 ifTrue: [ out cr ] ifFalse: [ out space ] ].
								each printOn: out base: 16 nDigits: 2 ] ]).
					'latin1' -> ([ ZnCharacterEncoder latin1 decodeBytes: self ]
											on: ZnCharacterEncodingError do: [ :exception | exception ]).
					'utf8' -> ([ ZnUTF8Encoder new decodeBytes: self ] 
											on: ZnCharacterEncodingError do: [ :exception | exception ]).
					'integer' -> self asInteger.
					'integer reversed' -> self reversed asInteger } ]
				ifFalse: [ #() ] ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!SettingTree methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 3/12/2015 09:23'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 0>
	composite tree 
		title: 'Tree';
		display: [ self settingTreeRoots ];
		children: [ :each | self childrenOf: each ];
		format: [ :each | each settingDeclaration label ] ! !

!Text methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 22:45'!
gtInspectorItemsIn: composite
	"No items presentation for a Text"! !

!Text methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/13/2014 23:30'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: -10>  
	 composite text
		title: 'Text';
		format: self! !

!WindowModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/2/2013 16:31'!
gtInspectorModelNestingIn: composite
	self model gtInspectorModelNestingIn: composite! !

!Symbol methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/19/2013 06:01'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Implementors';
		display: [ self systemNavigation allImplementorsOf: self ];
		when: [ (self systemNavigation allImplementorsOf: self) notEmpty ];
		showOnly: 30! !

!Symbol methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/17/2014 23:10'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Senders';
		display: [ self systemNavigation allSendersOf: self ];
		when: [ (self systemNavigation allSendersOf: self) notEmpty ];
		showOnly: 30;
		withSmalltalkSearch ! !

!Symbol methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/21/2016 07:08'!
pragmas
	^ (SystemNavigation default allBehaviors flatCollect: [ :each | 
		(Pragma allNamed: self in: each) 
			collect: [ :p | p method asRingDefinition ] ])! !

!SubscriptionRegistry methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/22/2016 01:10'!
gtInspectorSubscriptionsIn: composite
	<gtInspectorPresentationOrder: 0>
	composite table 
		title: 'Subscriptions';
		display: [ self subscriptions ];
		column: 'Class' evaluated: [ :each | each announcementClass ];
		column: 'Subscriber' evaluated: [ :each | each subscriber ]! !

!RBConjunctiveCondition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/15/2016 17:50'!
gtInspectorChildren
	^ { left . right }! !

!Class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'PavelKrivanek 11/18/2016 12:24'!
gtInspectorInstanceVariablesIn: composite
	"This provides a list of all class instance variables and the corresponding values"

	<localClassMethod> 
    "This method is supposed to be local in Class because of a good reason.
    We use this pragma to test if Class does not contain some accidental 
    local selectors."

	<gtInspectorPresentationOrder: 21>
	composite table
		title: 'InstVars';
		display: [ self class allInstVarNames sorted collect: [ :each | each -> (self instVarNamed: each) ] ];
		column: 'Variable' evaluated: [ :each | each key ];
		column: 'Value' evaluated: [ :each | each value ]! !

!Class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'PavelKrivanek 11/18/2016 12:24'!
gtInspectorMethodsIn: composite
	"This provides a list of all methods provided by the current class"

	<localClassMethod> 
    "This method is supposed to be local in Class because of a good reason.
    We use this pragma to test if Class does not contain some accidental 
    local selectors."

	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'Methods';
		display: [ (self methods collect: #asRingDefinition) 
						sorted: [ :x :y | x selector < y selector ] ];
		format: #selector;
		tags: [ :each | {each methodClass name} ]! !

!RBCompositeRefactoryChange methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/8/2016 11:59'!
gtInspectorPreviewIn: composite
	composite list 
		title: 'Changes';
		display: [ self changes ];
		when: [ self changes notEmpty ]! !

!SequenceableCollection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 12/1/2016 16:35'!
gtInspectorItemsIn: composite
	self size > self gtCollectionSizeThreshold ifTrue: [ ^ self ].
	^ composite table
		title: 'Items';
		display: [ :aCollection | [(1 to: self size) collect: [ :index | index -> (self at: index) ]] on:Error do:[#()]];
		beMultiple;
		searchOn: [:text :each | 
			Smalltalk compiler evaluate: ' | entity each | each := self. entity := each.', text for: each value logged: false];
		column: 'Index' evaluated: [ :assoc | assoc key asString ] width: 50;
		column: 'Item' evaluated: [ :assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ];
		send: [ :result | 
			result isNil
				ifTrue: [ nil ]
				ifFalse: [ result value size = 1 
					ifTrue: [result anyOne value]  
					ifFalse: [self species withAll: (result collect: [:each | each value])]]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/22/2015 19:03'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 95>
	(self hasProperty: #kmDispatcher) ifFalse: [^self].
	self kmDispatcher gtInspectorMappingsIn: composite! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 2/18/2016 16:49'!
gtInspectorMorphExtensionIn: composite
	<gtInspectorPresentationOrder: 15>
	
	^ composite table
		title: 'Extension';
		showOnly: 50; 
		display: [ self extension gtInspectorVariableValuePairs asSortedCollection ];
		when: [ extension notNil ];
		column: 'Variable' 
			evaluated: [:assoc | GTObjectPrinter new asNonTruncatedTextFrom: assoc key ];
		column: 'Value' 
			evaluated: [:assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ];
		send: #value;
		morphicSelectionAct: [:list | list selection value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse';
		morphicSelectionAct: [:list | list selection value inspect ] 
			icon: GLMUIThemeExtraIcons glamorousInspect 
			on: $i 
			entitled: 'Inspect';
		selectionAct: [:list | 
			((list selection pointersToExcept: { list selection })
									reject: [ :each | each pointsOnlyWeaklyTo: list selection ]) inspect ] 
			on: $t
			entitled: 'Open pointers to'! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StephaneDucasse 10/12/2016 18:26'!
gtInspectorMorphIn: composite
	<gtInspectorPresentationOrder: 90>
	| morphPresentation |
	morphPresentation := composite morph.
	morphPresentation
		title: 'Morph';
		display: [ [ self imageForm asMorph
				on: #mouseDown
				send: #value:
				to:
					[ :event | morphPresentation selection: (self morphsAt: event position) ] ]
				on: Error
				do: [ IconicListItem
						text: 'Error drawing Morph'
						icon: (self iconNamed: #smallWarningIcon) ] ];
		act: [ :pres | self exportAsPNG ] entitled: 'Export as PNG';
		act: [ :pres | self delete ] entitled: 'Delete'! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/19/2015 10:58'!
gtInspectorSubmorphsIn: composite
	<gtInspectorPresentationOrder: 80>  
	composite tree 
		title: 'Submorphs';
		rootsExpanded;
		display: [:each | {each} ];
		icon: [:each | | morphForm |
			morphForm := each imageForm.
			(morphForm extent x > 0 and: [morphForm extent y > 0 ])
				ifTrue: [(morphForm scaledToSize: 16@16) asMorph]
				ifFalse: [Form extent: 16@16] ];
		children: [:each | each submorphs];
		when: [:each | each submorphs notNil and:[ each hasSubmorphs ] ]! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 20:53'!
allProjects
	| all |
	all := OrderedCollection new.
	self allProjectsDo: [ :each |
		all add: each ].
	^ all! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 21:01'!
allProjectsDo: aBlock
	self allProjectsDo: aBlock withTraversedProjects: OrderedCollection new! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 21:30'!
allProjectsDo: aBlock withTraversedProjects: aCollection
	self projects do: [ :each |
		(each version notNil and: [(aCollection includes: each version) not]) 
		ifTrue: [
			aCollection add: each version.
			aBlock value: each version.
			each version allProjectsDo: aBlock withTraversedProjects: aCollection ] ]! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StephaneDucasse 10/13/2016 14:53'!
gtInspectorActionLoad
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self load ];
		iconName: #smallLoadProject;
		title: 'Load'! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/22/2016 13:51'!
gtInspectorPackagesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Packages';
		display: [ (self spec packages packageSpecsInLoadOrderFor: self spec) select: [ :each | 
				each isKindOf: MetacelloPackageSpec ] ]! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/13/2014 08:34'!
gtInspectorProjectsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Projects';
		display: [ self projects ]! !

!Time methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 20:12'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: [ 'Details' ];
		display: [ 
					{'hours' -> self hours.
					'minutes' -> self minutes.
					'seconds' -> self seconds.
					'nanoseconds' -> self nanoSecond.
					'meridian' -> self meridianAbbreviation.
					'iso' -> self print24 } ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!SocketStream methodsFor: '*GT-InspectorExtensions-Core' stamp: 'JurajKubelka 9/29/2015 15:39'!
gtInspectorSocketInfo: composite
	<gtInspectorPresentationOrder: 5>
	^ self socket ifNotNil: [ :aSocket | aSocket gtInspectorSocketInfo: composite ]! !

!Form methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/14/2014 06:51'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 90>  
	^ composite morph 
		title: 'Morph';
		display: [ self asMorph ]! !

!Duration methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 20:35'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: [ 'Details' ];
		display: [ 
					{'days' -> self days.
					'hours' -> self hours.
					'minutes' -> self minutes.
					'seconds' -> self seconds .
					'nanoseconds' -> self nanoSeconds } ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!SharedQueue methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 3/25/2016 18:20'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 0>
	composite fastList
		title: 'Items';
		display: [ items copy ];
		format: [ :each | each gtDisplayString ]! !

!MorphicTreeNodeAdapter methodsFor: '*GT-InspectorExtensions-Core' stamp: 'PeterUhnak 9/3/2015 17:42'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 30>
	
	"I do not provide morph preview."! !

!SmallDictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:52'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: 'Items';
		display: [ self associations ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		selectionAct: [ :table |
			table rawSelection do: [ :assoc | self removeKey: assoc key ].
			table update ]
			entitled: 'Remove item(s)';
		selectionPopulate: #selection 
			entitled: 'Open key'
			with: [ :table | (table rawSelection collect: #key) gtInspectorInterestingObject ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | selection isNil 
			ifTrue:[nil]
			ifFalse:[ (selection size = 1 ) 
				ifTrue: [ selection anyOne value ] 
				ifFalse: [ selection collect: #value ] ]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!TClassDescription methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:31'!
gtInspectorUsersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 	
		title: 'Users';
		when: [ self isTrait ];
		display: [ 
			self traitUsers asArray
			"Smalltalk allClasses select: [ :class |
			   class traitComposition traits includes: self ]" ]! !

!ComposableModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/2/2013 16:38'!
gtInspectorModelNestingIn: composite
	<gtInspectorPresentationOrder: 20>
	composite tree 
		title: 'Nesting';
		display: [ :root | { 'root' -> self } ];
		children: [ :each | 
			each value class allInstVarNames 
				collect: [ :iv | iv->(each value instVarNamed: iv) ]
				thenSelect: [ :association | 
					(association value isKindOf: ComposableModel) 
						and: [ (#('owner' 'window') includes: association key) not ] ] ];
		format: [ :association | association key , ': ' , association value asString ];
		send: #value! !

!ComposableModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'PeterUhnak 9/3/2015 17:42'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 30>
	
	self widget ifNotNil: [ :w | w gtInspectorPreviewIn: composite ]! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/12/2014 22:31'!
gtInspectorAllReferencesIn: composite
	"This provides a list of all methods provided by the current class"
	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'All Ref';
		display: [ (SystemNavigation default allReferencesTo: self binding) 
						sorted: [ :x :y | x name < y name ] ];
		format: #name;
		tags: [ :each | { each package name } ]! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/12/2014 22:32'!
gtInspectorAllReferencesOutsideIn: composite
	"This provides a list of all methods provided by the current class"
	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'All Ref Outside';
		display: [ ((SystemNavigation default allReferencesTo: self binding) 
							reject: [ :method | method package name == self package name ])
						sorted: [ :x :y | x name < y name ] ];
		format: #name;
		tags: [ :each | { each package name } ]! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 12/26/2014 14:11'!
gtInspectorCommentIn: composite
	"This provides an editable comment of the current class"
	<gtInspectorPresentationOrder: 20>
	composite text 
		title: 'Comment';
		display: [ self comment ];
		act: [ :text | 
			self comment: text text stamp: Author changeStamp]
			icon: GLMUIThemeExtraIcons glamorousAccept 
			on: $s
			entitled: 'Accept'! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/9/2016 23:22'!
gtInspectorDefinitionIn: composite
	<gtInspectorPresentationOrder: 15>
	composite pharoScript 
		title: 'Definition';
		display: [ self definition ] ! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/12/2014 22:30'!
gtInspectorMethodsIn: composite
	"This provides a list of all methods provided by the current class"
	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'Methods';
		display: [ (self allMethods collect: #asRingDefinition) 
						sorted: [ :x :y | x selector < y selector ] ];
		format: #selector;
		tags: [ :each | {each methodClass name} ]! !

!Date methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 20:04'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: [ 'Details' ];
		display: [ 
					{'year' -> self year.
					'month' -> self monthIndex.
					'month name' -> self monthName.
					'day of month' -> self dayOfMonth.
					'day of week' -> self dayOfWeekName.
					'day of year' -> self dayOfYear.
					'iso' -> self yyyymmdd } ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!Date methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 19:58'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite morph
		title: 'Calendar';
		morph: [ CalendarMorph on: self ]! !

!Bitmap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/22/2011 11:49'!
gtInspectorItemsIn: composite
	"No items presentation for a Bitmap"! !

!CompiledBlock methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:09'!
gtDisplayOn: stream
	self printOn: stream! !

!RBNamespace methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/8/2016 11:57'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 0>
	self changes isNil ifTrue: [ ^ self ].
	self changes gtInspectorPreviewIn: composite! !

!KMKeymap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/10/2014 07:07'!
gtDisplayOn: aStream
	aStream 
		nextPutAll: self name gtDisplayString;
		nextPutAll: ' on ';
		nextPutAll: self shortcut gtDisplayString;
		nextPutAll: ' do ' ;
		nextPutAll: self action gtDisplayString! !

!KMKeymap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/20/2014 22:11'!
gtInspectorSourceCodeIn: composite
	<gtInspectorPresentationOrder: 30> 

	^ self action gtInspectorSourceCodeIn: composite! !

!MetacelloProjectSpec methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 20:38'!
gtInspectorPackagesIn: composite
	<gtInspectorPresentationOrder: 40>
	self version gtInspectorPackagesIn: composite! !

!MetacelloProjectSpec methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 20:36'!
gtInspectorProjectsIn: composite
	<gtInspectorPresentationOrder: 40>
	self version gtInspectorProjectsIn: composite! !

!RPackageTag methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/6/2014 14:16'!
gtInspectorDefinedClassesIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list
		title: 'Classes';
		display: #classes;
		format: #gtDisplayString! !

!Announcer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'HenrikNergaard 2/18/2016 18:03'!
gtInspectorAnnouncementsIn: composite context: aGTContext
	<gtInspectorPresentationOrder: 40>
	| recordedAnnouncements messageSend |
	
	recordedAnnouncements := CollectionValueHolder value: OrderedCollection new.
	messageSend := MessageSend receiver: recordedAnnouncements selector: #addAnnouncementFirst:.
	self
		when: Announcement
		send: #cull:
		to: messageSend.
	aGTContext when: GLMBrowserClosing do: [ self unsubscribe: messageSend ].
	composite table
		title: 'Announcements';
		display: [ recordedAnnouncements value ];
		column: 'Time' evaluated: #key;
		column: 'Announcement' evaluated: #value;
		send: #value;
		showOnly: 50;
		format: #gtDisplayString;
		filterOn: [:text :each | Smalltalk compiler evaluate: '| date each | date := self key. each := self value. ', text for: each logged: false ];
		updateOn: Announcement from: recordedAnnouncements gtAnnouncer;
		act: [ :table | 
			recordedAnnouncements removeAll.
			table update ] 
			icon: GLMUIThemeExtraIcons glamorousCancel 
			entitled: 'Reset'! !

!Announcer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 9/30/2016 14:12'!
gtInspectorSubscriptionsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite table
		title: 'Subscriptions';
		display: [ self subscriptions glmSubscriptions ];
		when: [ self numberOfSubscriptions isZero not ];
		column: 'Subscriber' evaluated: [ :each | each subscriber asString ];
		column: 'Announcement' evaluated: [ :each | each announcementClass printString ];
		column: 'Kind' evaluated: [ :each | each class name ];
		act: [ :table | 
			self subscriptions reset.
			table update ] icon: GLMUIThemeExtraIcons glamorousCancel entitled: 'Reset';
		selectionAct: [ :table | 
			self subscriptions remove: table selection.
			table update ] entitled: 'Remove subscription'! !

!ZnMessage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/23/2015 17:07'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 40>
	self hasEntity
		ifTrue: [ 
			self contentType isBinary
				ifTrue: [ 
					composite table
						title: 'Contents';
						display: [ {'entity' -> self entity} ];
						column: 'Key' evaluated: #key;
						column: 'Value' evaluated: #value;
						send: #value ]
				ifFalse: [ 
					composite text
						title: 'Contents';
						format: self contents ] ]! !

!ZnMessage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 14:14'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers gtInspectorHeadersIn: composite) 
		title: [:anObject | self headers headers size asString , ' headers' ]! !

GLMCompositePresentation subclass: #GTSimpleRBTreeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Core'!

!GTSimpleRBTreeBrowser commentStamp: '<historical>' prior: 0!
This is a simple browser that displays the rb tree and previews each node on the source code.

Example:
self openOn: (self>>#compose) parseTree!

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 12/21/2013 23:09'!
compose
	self title: 'Tree'.
	self tabulator with: [ :browser |
		browser
			row: #tree;
			row: #source.
		browser transmit
			to: #tree;
			andShow: [ :a | self treeIn: a ].
		browser transmit
			to: #source;
			andShow: [ :a | self sourceIn: a ].
		browser transmit
			from: #tree;
			to: #source port: #selectionInterval;
			transformed: [ :rbNode | rbNode sourceInterval ].
		browser transmit
			toOutsidePort: #selection;
			from: #tree port: #selectedNode ]! !

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'AndreiChis 10/13/2015 21:42'!
sourceIn: a
	^ a pharoMethod 
		smalltalkClass: [ :each | each parents first methodClass ]; 
		display: [ :each | each source ]! !

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 8/23/2011 01:17'!
treeIn: a
	^ a tree
		rootsExpanded;
		display: [ :anObject | {anObject} ];
		children: [ :each | each children ];
		selectionPopulate: #selectedNode
			on: $o
			entitled: 'Open'
			with: [ :tree | tree selection ];
		format: [ :each | 
					String
						streamContents: [ :stream | 
							stream
								nextPutAll: each class name;
								nextPut: $(;
								nextPutAll: ((each formattedCode truncateTo: 50) copyReplaceAll: String cr with: String space);
								nextPut: $) ] ]! !

!Context methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/19/2017 12:19'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	(self method gtInspectorSourceIn: composite)
		doItReceiver: [ self receiver ];
		doItContext: [ self ]! !

!Context methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TommasoDalSasso 1/30/2015 16:58'!
gtInspectorVariableValuePairs
	"We override the variables with context specific ones"
	| superVariableValuePairs tempVariableValuePairs tempIndex |
	tempIndex := 0. 
	superVariableValuePairs := super gtInspectorVariableValuePairs.
	tempVariableValuePairs := (self tempNames
						collect: [ :tempName ||value|
							tempIndex := tempIndex + 1.
							value := [self debuggerMap namedTempAt: tempIndex in: self] 
								on: Error 
								do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
							('[' , tempName , ']') -> value ]) sort asOrderedCollection.
		^ tempVariableValuePairs addAll: superVariableValuePairs; yourself! !

!OrderedDictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:47'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: 'Items';
		display: [ self associations ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		selectionAct: [ :table |
			table rawSelection do: [ :assoc | self removeKey: assoc key ].
			table update ]
			entitled: 'Remove item(s)';
		selectionPopulate: #selection 
			entitled: 'Open key'
			with: [ :table | (table rawSelection collect: #key) gtInspectorInterestingObject ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | 
				selection isNil 
				ifTrue: [ nil ]
				ifFalse: [ selection size = 1  
					ifTrue: [ selection anyOne value ] 
					ifFalse: [ selection collect: #value ] ]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!GLMPane methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/4/2014 08:06'!
gtInspectorPortsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Ports';
		display: [ self ports ];
		column: 'Port' evaluated: [ :each | each name ];
		column: 'Value' evaluated: [ :each | each value asString ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/6/2014 13:18'!
gtDisplayOn: stream
	filesystem printPath: path on: stream! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 1/6/2016 22:36'!
gtInspectorActionMaterializeFuel
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ :composite | 
			| result |
			result := FLMaterializer materializeFromFileNamed: self fullName.
			composite selection: result ];
		icon: GLMUIThemeExtraIcons glamorousAdd;
		condition: [ self isFile and: [self extension = 'fuel' ] ];
		title: 'Materialize'! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/22/2016 08:49'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 5>
	composite text
			title: 'Contents';
			display: [ 
				self readStreamDo: [ :stream | 
					| result |
					result := [(stream next: 10000) asString]
						on: Error 
						do: [ (stream binary next: 10000) asString ].
					stream size > 10000
						ifTrue: [ result, '  ... truncated ...' ]
						ifFalse: [ result ] ] ];
			withLineNumbers: true;
			act: [ :text |
				self ensureDelete; writeStreamDo: [ :s | s nextPutAll: text text asString ] ]
				icon: GLMUIThemeExtraIcons glamorousSave
				on: $s
				entitled: 'Save';
			when: [ self isFile ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 1/6/2016 22:36'!
gtInspectorFuelIn: composite
	<gtInspectorPresentationOrder: 40>
	"(FileSystem disk workingDirectory / 'GTtest.fuel') writeStreamDo: [ :stream |
	FLSerializer newDefault
		at: #author putAdditionalObject: 'Author: Max Leske';
		at: #date putAdditionalObject: DateAndTime now;
		addPreMaterializationAction: [ Smalltalk inform: 'starting materialization' ];
		addPostMaterializationAction: [ :materialization | materialization inspect ];
		serialize: 'foo' on: stream binary ].
	
FLMaterializer materializeFromFileNamed: 'GTtest.fuel'"
	composite table
			title: 'Fuel Header';
			display: [
				(FLMaterializer materializeHeaderFromFileNamed: self fullName) gtGetMetaData ];
			column: 'Property' evaluated: [:assoc| assoc key ];
			column: 'Value' evaluated: [:assoc| assoc value];
			when: [ self isFile and: [self extension = 'fuel' ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 1/6/2016 22:37'!
gtInspectorGifIn: composite
	<gtInspectorPresentationOrder: 0>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | GIFReadWriter formFromStream: stream ] ];
			when: [ self isFile and: [self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imageGif ] ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TorstenBergmann 10/23/2015 01:07'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 0>
	^ composite table 
		title: 'Items';
		display: [ 
			| children |
			children := self directories, self files.
			self isRoot 
				ifTrue: [ children ]
				ifFalse: [ 
					children asOrderedCollection 
						addFirst: self parent;
						yourself ] ];
		column: 'Name' evaluated: [:each | (self isChildOf: each) 
								ifTrue: [ '..' ] 
								ifFalse: [ each basename ]] width: 400;
		column: 'Size' evaluated: [:each | each humanReadableSize] width: 100;
		column: 'Creation' evaluated: [ :each | 
			String streamContents: [:s | 
				each creationTime printYMDOn: s.
				s nextPut: Character space.
				each creationTime printHMSOn: s ]];
		icon: [ :each | 
			each isDirectory 
				ifTrue: [ GLMUIThemeExtraIcons glamorousFolder ] 
				ifFalse: [ GLMUIThemeExtraIcons glamorousBrowse ] ];
		when: [self isDirectory and: [self hasChildren]];
		selectionAct: [:table | table selection delete. table update] entitled: 'Delete';
		act: [ :table |
			 (UIManager default request: 'New Directory name?' initialAnswer: '') 
					ifNotNil: [:name | (self / name) ensureCreateDirectory ].
			 table update
			 ] icon: GLMUIThemeExtraIcons glamorousFolder entitled: 'Create Directory';		
		act: [ :table |
			 (UIManager default request: 'New File name?' initialAnswer: '') 
					ifNotNil: [:name | (self / name) ensureCreateFile ].
			 table update
			 ] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Create File';		
		act: [ :table | table update ] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Refresh'! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 1/6/2016 22:37'!
gtInspectorJpegIn: composite
	<gtInspectorPresentationOrder: 0>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | ImageReadWriter formFromStream: stream ] ];
			when: [ self isFile and: [self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imageJpeg ] ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 1/6/2016 22:38'!
gtInspectorPngIn: composite
	<gtInspectorPresentationOrder: 0>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | PNGReadWriter formFromStream: stream ] ];
			when: [ self isFile and: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imagePng ] ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 1/6/2016 22:38'!
gtInspectorStScriptIn: composite
	<gtInspectorPresentationOrder: 0>
	composite pharoScript
			title: 'Script';
			display: [ self readStreamDo: [ :s | s contents ] ];
			act: [ :text |
					text selectionInterval: (1 to: text text size).
					text highlightEvaluateAndDo: [ :result | text selection: result ] ]
				icon: GLMUIThemeExtraIcons glamorousGo
				on: $G
				entitled: 'Do it all and go';
			installDefaultSelectionActions;
			act: [ :text |
				self ensureDelete; writeStreamDo: [ :s | s nextPutAll: text text asString ] ]
				icon: GLMUIThemeExtraIcons glamorousSave
				on: $s
				entitled: 'Save';
			when: [ self isFile and: [ self extension = 'st' or: [self extension = 'ph'] ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 3/6/2016 22:40'!
gtInspectorZipItemsIn: composite
	<gtInspectorPresentationOrder: 0>
	^ composite table 
		title: 'Items';
		display: [ 
			| children root |
			root := (FileSystem zip: self) open workingDirectory.
			children := root directories, root files.
			self isRoot 
				ifTrue: [ children ]
				ifFalse: [ 
					children asOrderedCollection 
						addFirst: self parent;
						yourself ] ];
		column: 'Name' evaluated: [:each | self parent = each 
								ifTrue: [ '..' ] 
								ifFalse: [ each basename ]] width: 400;
		column: 'Size' evaluated: [:each | each humanReadableSize] width: 100;
		column: 'Creation' evaluated: [ :each | 
			String streamContents: [:s | 
				each creationTime printYMDOn: s.
				s nextPut: Character space.
				each creationTime printHMSOn: s ]];
		icon: [ :each | 
			each isDirectory 
				ifTrue: [ GLMUIThemeExtraIcons glamorousFolder ] 
				ifFalse: [ GLMUIThemeExtraIcons glamorousBrowse ] ];
		when: [ self isFile and: [ #('zip' 'jar' 'ear' 'war' 'mcz') includes: self extension ] ];
		act: [ :table | table update ] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Refresh'! !

!GLMPresentation methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/5/2016 23:29'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ composite tabulator with: [ :t |
		t title: 'Live'.
		t column: #default.
		t transmit 
			to: #default; 
			transformed: [:x | self entity ]; 
			andShow: [:a | a custom: self copy ].
		t transmit from: #default port: #selection; toOutsidePort: #selection ]! !

!GLMPresentation methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/4/2014 08:07'!
gtInspectorPanePortsIn: composite
	<gtInspectorPresentationOrder: 50>
	(self pane gtInspectorPortsIn: composite)
		title: 'Pane ports'! !

!Canvas methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/14/2014 06:51'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 40>
	^ self form gtInspectorFormIn: composite ! !

!UndefinedObject methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 16:04'!
gtInspectorSourceCodeIn: composite
	" nothing to do "! !

!MetacelloProjectReferenceSpec methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/11/2014 06:49'!
gtInspectorProjectsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Projects';
		display: [
			| projects |
			projects := OrderedCollection new.
			self
					projectDo: [:prj | projects add: prj ] 
					packageDo: [:pkg | ] 
					groupDo: [:ignored | ].
			projects ]
! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/29/2014 11:01'!
gtInspectorTransmissionsIn: composite
	<gtInspectorPresentationOrder: 35>  
	^ composite list 
		title: 'Transmissions';
		display: [ self transmissions ]! !

!ZnMimePart methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/23/2015 17:07'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 40>
	self hasEntity
		ifTrue: [ 
			self contentType isBinary
				ifTrue: [ 
					composite table
						title: 'Contents';
						display: [ {'entity' -> self entity} ];
						column: 'Key' evaluated: #key;
						column: 'Value' evaluated: #value;
						send: #value ]
				ifFalse: [ 
					composite text
						title: 'Contents';
						format: self contents ] ]! !

!ZnMimePart methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 14:17'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers gtInspectorHeadersIn: composite) 
		title: [:anObject | self headers headers size asString , ' headers' ]! !

!ZnStringEntity methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/23/2015 17:07'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>
	composite text
		title: 'Contents';
		format: self string! !

!DateAndTime methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 20:19'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: [ 'Details' ];
		display: [ 
					{'year' -> self year.
					'month' -> self monthIndex.
					'month name' -> self monthName.
					'day of month' -> self dayOfMonth.
					'day of week' -> self dayOfWeekName.
					'day of year' -> self dayOfYear.
					'hours' -> self hours.
					'minutes' -> self minutes.
					'seconds' -> self seconds.
					'nanoseconds' -> self nanoSecond.
					'meridian' -> self meridianAbbreviation.
					'offset' -> self offset.
					'date' -> self asDate.
					'time' -> self asTime.
					'iso' -> self printString.
					'utc' -> self asUTC } ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!KMRepository methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/20/2014 21:53'!
gtInspectorGlobalsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Global keys';
		display: [ 
			self globalCategories
				flatCollect: [ :category | 
					category allEntries keymaps collect: [ :key | key -> category ] ]
				 ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!KMRepository methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/27/2015 20:59'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Keys';
		display: [ 
			self categories values
				flatCollect: [ :category | 
					category allEntries keymaps collect: [ :key | key -> category ] ]
				 ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!KMCategory methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/20/2014 08:20'!
gtDisplayOn: stream
	^ stream nextPutAll: self name asString! !

!KMCategory methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/9/2014 22:05'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Keys';
		display: [ self allEntries keymaps ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		format: #gtDisplayString;
		when: [ self allEntries keymaps notEmpty ]! !

!Dictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:50'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: 'Items';
		display: [ self associations ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		selectionAct: [ :table |
			table rawSelection do: [ :assoc | self removeKey: assoc key ].
			table update ]
			entitled: 'Remove item(s)';
		selectionPopulate: #selection 
			entitled: 'Open key'
			with: [ :table | (table rawSelection collect: #key) gtInspectorInterestingObject ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | 
			selection isNil 
			ifTrue:[nil]
			ifFalse:[ (selection size = 1) 
				ifTrue: [ selection anyOne value ] 
				ifFalse: [ selection collect: #value ] ]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!Dictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SeanDeNigris 8/11/2015 08:52'!
gtInspectorKeysIn: composite
	<gtInspectorPresentationOrder: 1>

	^ composite list
		title: 'Keys';
		display: [ self keys ]! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorASTIn: composite
	<gtInspectorPresentationOrder: 35> 
	(GTSimpleRBTreeBrowser new treeIn: composite)
		title: 'AST';
		display: [ :anObject | {anObject ast} ]
		! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorBytecodeIn: composite
	<gtInspectorPresentationOrder: 30> 
	^ (GTBytecodeBrowser new treeIn: composite)
		title: 'Bytecode'! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorBytesIn: composite
	<gtInspectorPresentationOrder: 30>
	"It makes no sense to view me as a collection of bytes"! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorHeaderIn: composite
	<gtInspectorPresentationOrder: 40> 
	composite text 
		title: 'Header';
		display: [ self headerDescription ]! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorIrIn: composite
	<gtInspectorPresentationOrder: 35> 
	composite text 
		title: 'Ir';
		display: [ :anObject || string |
				string := anObject ir longPrintString.
				string copyFrom: 2 to: string size ]! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorItemsIn: composite
	"It makes no sense to view me as a collection of items"! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite tabulator 
		title: 'Pragmas';
		when: [ :x | x pragmas notEmpty ];
		with: [ :t |  
			t row: #pragmas; row: #methods.
			t transmit to: #pragmas; andShow: [:a | 
				a list
					title: 'Pragmas';
					display: [ :method | method pragmas ];
					when: [ :x | x pragmas notEmpty ] ].
			t transmit from: #pragmas; to: #methods; andShow: [:a | 
				a list 
					title: 'Methods';
					display: [ :pragma | 
						| methods | 
						methods := OrderedCollection new.
						Object withAllSubclassesDo: [ :each | 
							methods addAll: ((Pragma allNamed: pragma keyword in: each) collect: #method) ].
						methods ];
					format: #selector ].
			t transmit
				toOutsidePort: #selection;
				from: #methods port: #selection
		];
		startOn: self! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite pharoMethod
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self sourceCode ];
		act: [ self browse ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse'! !

!CompiledCode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'ClementBEra 9/12/2016 11:05'!
gtInspectorVariableValuePairs
	| literalIndex values |
	literalIndex := 0.
	values := OrderedCollection new.
	values addAll: (self literals collect: [ :aLiteral | 'literal', ( literalIndex := literalIndex + 1 ) asString -> aLiteral ]).
	self initialPC to: self size do: [ :index |
		values add:  ('bc ', index asString) ->  (self at: index)].
	^values.
	
! !

!Bag methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/24/2016 09:01'!
gtInspectorItemsIn: composite
	"Disable the Items presentation for a bag.
	This avoid showing all duplicated items."! !

!Bag methodsFor: '*GT-InspectorExtensions-Core' stamp: 'JurajKubelka 12/22/2016 16:14'!
gtInspectorOccurrencesIn: composite
	<gtInspectorPresentationOrder: 1>  
	^ (composite fastTable)
		title: 'Occurrences';
		display: [ :aCollection | self asSet asOrderedCollection ];
		column: 'Item' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each ];
		column: 'Occurences' 
			evaluated: [ :each | self occurrencesOf: each ]
			sortedBy: [ :a :b | (self occurrencesOf: a) > (self occurrencesOf: b)];
		beMultiple;
		"withSmalltalkSearch;"
		showOnly: 50;
		send: [ :result |
				result ];
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!GLMTransmission methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/29/2014 11:07'!
gtDisplayOn: stream
	self origins asArray gtDisplayOn: stream.
	stream nextPutAll: '->'.
	self destination gtDisplayOn: stream! !

!MCRepository methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StephaneDucasse 10/13/2016 14:52'!
gtInspectorGoferReferencesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Gofer';
		display: [ self goferReferences sorted ];
		format: [ :each | each name asString ];
		icon: [ Smalltalk ui icons iconNamed: #packageIcon ];
		act: [ :com | 
			com selection
				ifNotNil: [ :each | 
					Gofer new
						repository: com entity;
						version: each name;
						load ] ]
			iconName: #downIcon
			entitled: 'Load'! !

!MethodChunk methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/19/2016 13:39'!
gtDisplayOn: stream
	stream nextPutAll: self description! !

!MetacelloSpec methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/23/2015 17:16'!
gtInspectorCodeIn: composite
	<gtInspectorPresentationOrder: 40>
	composite pharoScript 
		title: 'Code';
		display: [ 
			String streamContents: [ :s | self configMethodOn: s indent: 0] ]
! !

!ZnHeaders methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 14:08'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers gtInspectorItemsIn: composite) 
		display: [ :anObject | self headers associations ];
		title: [ :anObject | self headers size asString , ' items' ]! !

!Float methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 12/1/2014 21:52'!
gtInspectorFloatIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Float';
		display: [ 
			(self respondsTo: #binaryLiteralString)
				ifTrue: [
					{'binary' -> self binaryLiteralString.
					'significand' -> self significand.
					'exponent' -> self exponent} ]
				ifFalse: [
					{'significand' -> self significand.
					'exponent' -> self exponent} ] ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!Float methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TommasoDalSasso 1/30/2015 16:42'!
gtInspectorVariableValuePairs
	
	^ OrderedCollection
		with: '1' -> (self at: 1)
		with: '2' -> (self at: 2)! !

!CollectionValueHolder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 8/21/2014 17:37'!
addAnnouncementFirst: ann

	^ self addFirst: (DateAndTime now -> ann)! !

!FLHeader methodsFor: '*GT-InspectorExtensions-Core' stamp: 'MaxLeske 3/4/2014 11:55'!
gtGetMetaData
	|assoc|
	
	assoc := OrderedCollection new.
	assoc add: ('Meta' ->(String streamContents: [ :stream |
		additionalObjects do: [ :add | add printOn: stream. stream crlf ]])).
	assoc add: ('Pre materialization actions:' -> (String streamContents: [ :stream |
		preMaterializationActions do: [ :action | action printOn: stream ]])).
	assoc add: ('Post materialization actions: ' -> (String streamContents: [ :stream |
		postMaterializationActions do: [ :action | action printOn: stream ]])).
	^ assoc! !

!Set methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 12/27/2016 21:16'!
gtInspectorItemsIn: composite
	"we override this because sets do not work well in morph tree morphs"

	^ (super gtInspectorItemsIn: composite)
		display: [ :set | set asOrderedCollection ]! !

!ZnStatusLine methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/23/2015 17:07'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite text
		title: 'HTTP';
		format: [ String streamContents: [ :out | self writeOn: out ] ]! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 3/25/2015 09:48'!
gtDisplayOn: aStream
	aStream print: self methodClass; nextPutAll: '>>'; store: self selector.! !

!ZnRequestLine methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/23/2015 17:07'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite text
		title: 'HTTP';
		format: [ String streamContents: [ :out | self writeOn: out ] ]! !

!RBProgramNode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/14/2015 11:36'!
gtInspectorSourceCodeIn: composite
	<gtInspectorPresentationOrder: 30> 

	^ composite pharoMethod 
		title: 'Source code';
		display: [ self source ];
		smalltalkClass: [ 
			self parents first compilationContext ifNotNil: [ :ctx | ctx getClass ] ]; 
		initialize: [ :presentation | 
			presentation selectionInterval: self sourceInterval ];
		when: [ self source notNil ];
		act: [ self methodNode method compiledMethod browse ] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'! !

!RBProgramNode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/14/2014 10:29'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 30> 
	^ (GTSimpleRBTreeBrowser new treeIn: composite)
		title: 'Tree'! !

!MessageTally class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 5/26/2014 07:57'!
on: aBlock
	"This utility method constructs a tally object and returns it without
	triggering the construction of the default report"
	^ MessageTally new
		spyEvery: 1
		on: aBlock;
		yourself ! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
children
	^ self sonsOver: 0! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 22:28'!
gtDisplayIdentifierOn: aStream
	class gtDisplayOn: aStream.
	self method methodClass ~~ class 
		ifTrue: [ aStream nextPut: $(; print: self method methodClass; nextPut: $) ].
	aStream 
		nextPutAll: '>>';
		store: self method selector! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 22:29'!
gtDisplayOn: aStream
	self gtDisplayIdentifierOn: aStream.
	aStream 
		nextPutAll: ' (';
		nextPutAll: self tally printString;
		nextPutAll: ')'! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:10'!
gtInspectorReportIn: composite
	<gtInspectorPresentationOrder: 60>
	^ composite text
		title: 'Report';
		display: [ String streamContents: [:s | self report: s ] ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/4/2014 22:56'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 50>
	^ self method ifNotNil: [
		self method gtInspectorSourceIn: composite]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
localTally
	^ self children 
		inject: self tally
		into: [ :diff :each | diff - each tally ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
localTime
	^ self children
		inject: self time 
		into: [ :diff :each | diff - each time ]! !

!MCPackageManager class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/21/2014 13:09'!
gtInspectorManagersIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Managers';
		display: [ self allManagers sorted: [ :x :y | x packageName < y packageName ] ];
		format: #packageName;
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ]! !

!MCPackageManager methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/4/2014 21:53'!
gtDisplayOn: stream
	stream nextPutAll: self package name! !

!HelpTopic methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StephaneDucasse 6/16/2016 08:46'!
gtInspectorActionOpenHelpBrowser
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ HelpBrowser openOn: self ];
		icon: (Smalltalk ui icons iconNamed: #bookIcon);
		title: 'Browse'! !

!HelpTopic methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/6/2015 10:36'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 40>
	
	composite text
		title: 'Contents';
		display: [ self contents ];
		when: [ self contents notEmpty  ] ! !

!HelpTopic methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/6/2015 10:28'!
gtInspectorSubtopicsIn: composite
	<gtInspectorPresentationOrder: 50>

	composite tree
		shouldValidate: false;
		title: 'Subtopics';
		display: [ self subtopics ];
		children: [ :each | each subtopics ];
		when: [ self hasSubtopics ];
		format: #title! !

!SettingNode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/22/2015 18:44'!
gtInspectorLiveIn: composite
	<gtInspectorPresentationOrder: 0>
	composite morph
		title: 'Live';
		display: [ self settingDeclaration inputWidget ];
		when: [ self settingDeclaration notNil and: [ self settingDeclaration inputWidget notNil ] ]! !

!Socket methodsFor: '*GT-InspectorExtensions-Core' stamp: 'JurajKubelka 9/30/2015 05:42'!
gtInspectorSocketInfo: composite
	<gtInspectorPresentationOrder: 1>
	^ ((Dictionary new
		at: #isConnected put: self isConnected;
		at: #address put: self localAddress;
		at: #port put: self localPort;
		at: #isOtherEndClosed put: self isOtherEndClosed;
		at: #isThisEndClosed put: self isThisEndClosed;
		at: #isUnconnected put: self isUnconnected;
		at: #isUnconnectedOrInvalid put: self isUnconnectedOrInvalid;
		at: #isValid put: self isValid;
		at: #isWaitingForConnection put: self isWaitingForConnection;
		yourself)
			gtInspectorItemsIn: composite)
				title: 'Socket Info'! !

!FileSystem methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorRootItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	(self root gtInspectorItemsIn: composite)
		title: 'Root directory'! !

!FileSystem methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorWorkingDirectoryItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	(self workingDirectory gtInspectorItemsIn: composite)
		title: 'Working directory'! !

!NewValueHolder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/5/2014 21:46'!
gtAnnouncer
	^ announcer! !

!NewValueHolder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/18/2014 23:27'!
gtInspectorPresentationsIn: composite inContext: aGTInspector
	composite 
		updateOn: Announcement from: announcer.
	super gtInspectorPresentationsIn: composite inContext: aGTInspector! !

!Color methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/18/2013 11:46'!
gtInspectorColorIn: composite
	<gtInspectorPresentationOrder: 30>
	composite morph 
		title: 'Color';
		display: [ BorderedMorph new color: self ]! !

!RBAbstractCondition class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/3/2016 10:22'!
gtExampleBasic
	<gtExample>
	^ RBCondition new
		type: { }
		block: [ true ]
		errorString: #'error'! !

!RBAbstractCondition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/15/2016 17:48'!
gtInspectorChildren
	^ #()! !

!RBAbstractCondition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/3/2016 10:18'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 0>
	composite tree
		title: 'Tree';
		display: [ { self } ]	;
		children: [ :each | each gtInspectorChildren ];
		when: [ self gtInspectorChildren notEmpty ]! !

!MetacelloDirective methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 9/11/2015 21:16'!
gtInspectorChildren
	^ {}! !

!ZnRequest methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 15:18'!
gtInspectorRequestIn: composite
	<gtInspectorPresentationOrder: 25>
	(self requestLine gtInspectorTextIn: composite)
		title: 'Request'! !

!SmalltalkImage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/6/2015 12:39'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 0>
	composite table
		title: 'Details';
		display: [ 
			{ 
				'Image directory' -> self imageDirectory asFileReference.
				'Image format version' -> self imageFormatVersion.
				'License' -> self licenseString.
				'VM directory' -> self vmDirectory asFileReference.
				'VM version' -> self version
			} ];
		column: 'Property' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!MetacelloVersionLoadDirective methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 9/11/2015 21:16'!
gtInspectorChildren
	^ self loadDirectives! !

!MetacelloVersionLoadDirective methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 9/11/2015 21:35'!
gtInspectorLoadDirectivesIn: composite
	<gtInspectorPresentationOrder: 1>
	composite tree
		title: 'Load directives';
		display: [ { self } ];
		format: [:each | each label ifEmpty: [each title]];
		rootsExpanded;
		children: #gtInspectorChildren;
		filterOn: [:text :each | '*', text, '*' match: each label ]! !

!VirtualMachine methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/6/2015 12:34'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 0>
	composite table
		title: 'Details';
		display: [ 
			{ 
				'VM directory' -> self vmDirectory asFileReference.
				'VM build date' -> self buildDate.
				'VM version' -> self version.
				'Image directory' -> self imagePath asFileReference parent.
				'Image version' -> self imageVersionNumber.

			} ];
		column: 'Property' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!ZnResponse methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 15:18'!
gtInspectorResponseIn: composite
	<gtInspectorPresentationOrder: 25>
	(self statusLine gtInspectorTextIn: composite)
		title: 'Response'! !

!ThemeIcons methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/10/2016 08:09'!
gtInspectorIconsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Icons';
		display: [ icons associations sorted: [ :a :b | a key < b key ] ];
		icon: [ :each | each value ];
		format: [ :each | each key ]! !
